Foreman - Feature #2334

location matcher doesn't match on smart parameters
03/18/2013 05:34 AM - David Schmitt

Status: Closed

Priority: Normal

Assignee: Joseph Magen

Category: Organizations and Locations

Target version: 1.2.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:

Pull request:

Description

Version 1.1stable, running on Scientific Linux 6.x
I've got a parameterized class that should receive different arguments depending on the location of a node.

I've added location to the override order list and specified the new override with "location=TheLocation" and a value, but the value
does not appear in the ENC output of the node, although both the class and the location appear correctly in the YAML.

Associated revisions

Revision ¢7f52777 - 06/12/2013 11:16 AM - Joseph Magen

fixes #2334 - location matcher doesn't match on smart parameters
Revision 696e9499 - 06/12/2013 04:11 PM - Joseph Magen
fixes #2334 - location matcher doesn't match on smart parameters

(cherry picked from commit c7f527779d80e1cc78e1f3b02a6ba7bfc081a95d)

History

#1 - 03/18/2013 11:22 AM - Sam Kottler
- Category set to Organizations and Locations

- Target version set to 1.2.0

#2 - 05/16/2013 08:45 AM - Greg Sutcliffe

- Tracker changed from Bug to Feature

Gonna set this as a Feture (more of an Enchancement) for the class-param work.

#3 - 05/21/2013 10:49 AM - Joseph Magen

- Status changed from New to Need more information

David, | replicated your scenario and the overridden value appears in the ENC output for me. Can you provide more information.

#4 - 05/21/2013 10:51 AM - Joseph Magen

- Assignee set to Joseph Magen

#5 - 05/22/2013 02:19 AM - David Schmitt

I've got a host that has a class added via a hostgroup.

On the class, | add a smart variable (for testing, | assume the same matching mechanisms also apply to class params).
This is the configuration of the smart variable:

Name: loc_test

05/17/2024 1/3




Description: test for location matching
Type: string

Default value: default

Order: fgdn hostgroup os domain location
Match: location=abc

Value: abc

Here is the output from https://foreman/hosts/testhost/externalNodes?name=testhost

classes:
theclass:
parameters:
location: abc
loc_test: default

#6 - 05/28/2013 04:39 AM - Joseph Magen

- Status changed from Need more information to Assigned

David, yes the matching mechanism is the same whether it's a smart variable (global) or smart class parameter
The smart variables appear in the yaml files under "parameters:" as in your example above.
The smart class parameters appear in the yaml files under "classes:" and then under the particular class it refers to.

| duplicated your exact example and "loc_test: abc" appears in the yaml output under parameters. | can't figure out what's wrong with your example.
I'm sure that the smart variable "loc_test" was added to the class called "theclass". If so, it should work????

#7 - 05/30/2013 03:53 AM - Joseph Magen

David, can this issue be closed?

#8 - 06/03/2013 10:56 AM - David Schmitt

Retesting this, | found a deeper cause of my problem:

For some reason the displayed and the actual name of the location do not have the same case. At most places in the Ul, the location is displayed with
title case (i.e. first letter capitalized), but in the :edit, the name is entered all lower case.

| always tried matching to the lowercase version (which is also what can be seen in the YAML output and the database (taxonomies table), but
actually the upcased version is matched.

Demo:

class: loctest

param: var

matcherl: location=rcv, valuel: lowercase
matcher2: location=Rcv, value2: uppercase

(pruned) output:

parameters:
location: rcv
classes:
"bi::loctest":
var: uppercase

foreman=# select * from taxonomies;

id | name | type | created_at | updated_at | ignore_types

——— Fo— o o o ———
2 | rcv | Location | 2013-01-28 12:24:14.135418 | 2013-02-11 16:26:10.407401 | —-—— []

This effect vanishes if the to_label function of app/models/taxonomy.rb is changed as follows:
def to_label
# name =~ /[A-Z]/ ? name : name.capitalize

name
end

#9 - 06/05/2013 04:49 AM - Joseph Magen

thanks David, | will look into this further
https://foreman/hosts/testhost/externalNodes?name=testhost

#10 - 06/06/2013 11:52 AM - Joseph Magen

David, | sent a pull request https:/github.com/theforeman/foreman/pull/700 with your fix.
As a rule, | feel that changing uppercase, lowercase, etc should only be in the Ul and not in business logic. The matcher should match whatever the
user enters. | didn't realize that the code matches on #to_label, but apparently your test shows that it does.

#11 - 06/12/2013 11:17 AM - Joseph Magen
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset c7f527779d80e1cc78e1f3b02a6ba7bfc081a95d.
